pro ct,l,rphi,rthe,out


	N=2*l+1
	ctheta=dblarr(N,N)
	z0=dblarr(N)
	c0=dblarr(N)
	z0f=dblarr(N)
	c0f=dblarr(N)
	ccos=dblarr(N,N)
	csin=dblarr(N,N)
	out=dblarr(N,N)
	out0=dblarr(N,N)
	xx=(findgen(101)/50.-1.)
	
	rthe=rthe*!pi/180.
	rphi=rphi*!pi/180.

	x=xx*sin(rthe)

	phi=xx*rphi

;	!p.multi=[0,1,2]

;	plot,x

;	plot,phi

; Correction of surface

	zx=x
	zphi=phi

	zx(*)=1.
	zphi(*)=1.


	surf=3.141592654/(int_tabulated(x,zx)*int_tabulated(phi,zphi))

;	print,surf



; Integration of velocity


		
	for j=0,N-1 do begin
		mp=j-l
			
			y2=(-1)^abs(mp)*legendre(l,abs(mp),x)
		
; apodization is mu=sin(theta)*cos(phi)
;			z0(j)=int_tabulated(x,y2*(1-x^2))
; no apodization
			z0(j)=int_tabulated(x,y2*sqrt(1-x^2))
	endfor
	
	for j=0,N-1 do begin
		mp=j-l
		z2=cos(mp*phi)
; apodization is mu=cos(theta)*sin(phi)
;		c0(j)=int_tabulated(phi,z2*cos(phi)^2)
; no apodization
		c0(j)=int_tabulated(phi,z2*cos(phi))/3.141592654
	endfor

; ******************************

; Integration of filter

	for j=0,N-1 do begin
		mp=j-l
			
			y2=(-1)^abs(mp)*legendre(l,abs(mp),x)
		
; apodization is mu=sin(theta)*cos(phi)
;			z0f(j)=int_tabulated(x,y2*sqrt(1-x^2))
; no apodization
			z0f(j)=int_tabulated(x,y2)
	endfor
	
	for j=0,N-1 do begin
		mp=j-l
		z2=cos(mp*phi)
; apodization is mu=cos(theta)*sin(phi)
;		c0f(j)=int_tabulated(phi,z2*cos(phi))/3.141592654
; no apodization
		c0f(j)=int_tabulated(phi,z2)/3.141592654
	endfor

;	print,c0(*,0)

;	print,z0(*,0)

;	print,c0f(*,0)

;	print,z0F(*,0)


; ********************************

	for i=0,N-1 do begin
		m=i-l

			y1=(-1)^abs(m)*legendre(l,abs(m),x)
		
		for j=0,N-1 do begin
			mp=j-l
			
				y2=(-1)^abs(mp)*legendre(l,abs(mp),x)
		
; apodization is mu=sin(theta)*cos(phi)
;			ctheta(i,j)=int_tabulated(x,y1*y2*(1-x^2))
; no apodization
			ctheta(i,j)=int_tabulated(x,y1*y2*sqrt(1-x^2))
		endfor
	endfor
	
	for i=0,N-1 do begin
		m=i-l
		z1=cos(m*phi)
		for j=0,N-1 do begin
			mp=j-l
			z2=cos(mp*phi)
; apodization is mu=cos(theta)*sin(phi)
;			ccos(i,j)=int_tabulated(phi,z1*z2*cos(phi)^2)/3.141592654
; no apodization
			ccos(i,j)=int_tabulated(phi,z1*z2*cos(phi))/3.141592654
		endfor
	endfor
	for i=0,N-1 do begin
		m=i-l
		z1=sin(m*phi)
		for j=0,N-1 do begin
			mp=j-l
			z2=sin(mp*phi)
; apodization is mu=cos(theta)*sin(phi)
;			csin(i,j)=int_tabulated(phi,z1*z2*cos(phi)^2)/3.141592654
; no apodization
			csin(i,j)=int_tabulated(phi,z1*z2*cos(phi))/3.141592654
		endfor
	endfor


; ***********************************


	for m=-l,l do begin
		i=m+l
		bb0=z0f(i)*c0f(i)
		for mp=-l,l do begin
			j=mp+l
		
			aa0=z0(j)*c0(j)	

			out0(i,j)=aa0*bb0/2.

;			print,'crosstalk between',m,'and',mp,'=',(ccos(i,j)+csin(i,j)),out(i,j),i,j
			;out(j,i)=out(i,j)
		endfor
;		print,''
	endfor

; Correction of mean velocity from surface area

	out0=out0*surf

;	print,out0

	for m=-l,l do begin
		i=m+l
		bb=ctheta(i,i)*(ccos(i,i)+csin(i,i))/2.
		for mp=-l,l do begin
			j=mp+l

			aa=ctheta(i,j)*(ccos(i,j)+csin(i,j))/2.

			

			
					
		

;			print,m,mp,aa,bb,out0(i,j),out0(i,i)


;			aa=(ctheta(i,j)*(ccos(i,j)+csin(i,j)))

;			bb=(ctheta(i,i)*(ccos(i,i)+csin(i,i)))


			out(i,j)=(aa-out0(i,j))/(bb-out0(i,i))*(1.-(abs(m+mp) mod 2))

;			print,'crosstalk between',m,'and',mp,'=',aa/bb
			;out(j,i)=out(i,j)
		endfor
;		print,''
	endfor

;	print,out
end
